<!DOCTYPE html>
<html lang="en">

<head>
    <title>Documents - Dokumenta</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="icon" type="image/ico" href="{{ url_for('static', filename='favicon.ico') }}">

    <link rel="stylesheet" href="{{ url_for('static', filename='vendors/mdi/css/materialdesignicons.min.css') }}">
    <link rel="stylesheet" href="{{ url_for('static', filename='css/style.css') }}">
    <script src="{{ url_for('static', filename='js/redirection.js') }}"></script>
</head>

<body>
    <div class="container-scroller">
        <nav class="sidebar sidebar-offcanvas" id="sidebar">
            <div class="sidebar-brand-wrapper d-none d-lg-flex align-items-center justify-content-center fixed-top">
                <a class="sidebar-brand brand-logo" href="/"><img src="{{ url_for('static', filename='images/logo.svg') }}" alt="Logo"></a>
                <a class="sidebar-brand brand-logo-mini" href="/"><img src="{{ url_for('static', filename='images/logo-mini.svg') }}" alt="Logo Mini"></a>
            </div>
            <ul class="nav">
                <li class="nav-item nav-category">
                    <span class="nav-link">Navigation</span>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/">
                        <span class="menu-icon">
                            <i class="mdi mdi-speedometer"></i>
                        </span>
                        <span class="menu-title">Dashboard</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/categories">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Categories</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/documents">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Documents</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/users">
                        <span class="menu-icon">
                            <i class="mdi mdi-table-large"></i>
                        </span>
                        <span class="menu-title">Users</span>
                    </a>
                </li>
                <li class="nav-item menu-items">
                    <a class="nav-link" href="/docs/v1" target="_blank">
                        <span class="menu-icon">
                            <i class="mdi mdi-file-document-box"></i>
                        </span>
                        <span class="menu-title">API Documentation</span>
                    </a>
                </li>
            </ul>
        </nav>
        <div class="container-fluid page-body-wrapper">
            <nav class="navbar p-0 fixed-top d-flex flex-row">
                <div class="navbar-brand-wrapper d-flex d-lg-none align-items-center justify-content-center">
                    <a class="navbar-brand brand-logo-mini" href="/"><img src="{{ url_for('static', filename='images/logo-mini.svg') }}" alt="Logo Mini"></a>
                </div>
                <div class="navbar-menu-wrapper flex-grow d-flex align-items-stretch">
                    <button class="navbar-toggler navbar-toggler align-self-center" type="button" data-toggle="minimize">
                        <span class="mdi mdi-menu"></span>
                    </button>
                    <ul class="navbar-nav w-100"></ul>
                    <ul class="navbar-nav navbar-nav-right">
                        <li class="nav-item dropdown">
                            <a class="nav-link" id="profileDropdown" href="#" data-toggle="dropdown">
                                <div class="navbar-profile">
                                    <p class="mb-0 d-none d-sm-block navbar-profile-name" id="usernameTopRight">USERNAME</p>
                                    <i class="mdi mdi-menu-down d-none d-sm-block"></i>
                                </div>
                            </a>
                            <div class="dropdown-menu dropdown-menu-right navbar-dropdown preview-list" aria-labelledby="profileDropdown">
                                <a class="dropdown-item preview-item" id="logoutButton">
                                    <div class="preview-thumbnail">
                                        <div class="preview-icon bg-dark rounded-circle">
                                            <i class="mdi mdi-logout text-danger"></i>
                                        </div>
                                    </div>
                                    <div class="preview-item-content">
                                        <p class="preview-subject mb-1">Logout</p>
                                    </div>
                                </a>
                            </div>
                        </li>
                    </ul>
                    <button class="navbar-toggler navbar-toggler-right d-lg-none align-self-center" type="button" data-toggle="offcanvas">
                        <span class="mdi mdi-format-line-spacing"></span>
                    </button>
                </div>
            </nav>

            <div class="main-panel">
                <div class="content-wrapper">
                    <div class="row">
                        <div class="col-lg-12 grid-margin stretch-card">
                            <div class="card">
                                <div class="card-body">
                                    <h4 class="card-title">Documents (page <span id="currentPage">1</span>)</h4>

                                    <button type="button" class="btn btn-primary p-1 px-2" data-toggle="modal" data-target="#createModal">
                                        <i class="mdi mdi-plus mdi-18px m-0"></i>
                                    </button>

                                    <div class="table-responsive">
                                        <table class="table table-striped" id="table">
                                            <thead>
                                                <tr>
                                                    <th style="width: 150px;">#</th>
                                                    <th>Title</th>
                                                    <th>File Type</th>
                                                    <th class="fit">Action</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr class="d-none table-row">
                                                    <td class="document_id">ID</td>
                                                    <td class="document_title">TITLE</td>
                                                    <td class="document_file_type">FILE_TYPE</td>
                                                    <td class="fit">
                                                        <div class="f-flex">
                                                            <a class="btn btn-primary mr-1 p-1 px-2 btn-download" target="_blank">
                                                                <i class="mdi mdi-folder-open mdi-18px m-0"></i>
                                                            </a>
                                                            <button class="btn btn-info mx-1 p-1 px-2 btn-update">
                                                                <i class="mdi mdi-pencil mdi-18px m-0"></i>
                                                            </button>
                                                            <button class="btn btn-danger ml-1 p-1 px-2 btn-delete">
                                                                <i class="mdi mdi-delete mdi-18px m-0"></i>
                                                            </button>
                                                        </div>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>



                                        <div class="d-flex">
                                            <div class="mt-3 mb-1">
                                                <button type="button" class="btn btn-primary p-2" id="sortToggleButton">
                                                    Sort : ASC
                                                </button>
                                            </div>
                                            <div class="mt-3 mb-1 ml-auto">
                                                <button type="button" class="btn btn-primary p-2" id="prevPageButton">
                                                    Prev Page
                                                </button>
                                                <button type="button" class="btn btn-primary p-2 ml-2" id="nextPageButton">
                                                    Next Page
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <footer class="footer">
                    <div class="d-sm-flex justify-content-center justify-content-sm-between">
                        <span class="text-muted d-block text-center text-sm-left d-sm-inline-block">Copyright 2021 Florian Burgener</span>
                    </div>
                </footer>
            </div>
        </div>
    </div>

    <div class="modal fade" id="createModal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Document Create</h5>
                    <button type="button" class="close" data-dismiss="modal">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-danger error-message" role="alert" style="display: none;">
                        EMPTY
                    </div>

                    <form class="forms-sample" id="createForm">
                        <div class="form-group">
                            <label for="titleInput">Title *</label>
                            <input type="text" class="form-control" id="titleInput" placeholder="Title">
                        </div>
                        <div class="form-group">
                            <label>File *</label>
                            <input class="form-control" type="file" id="fileInput">
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger px-3 py-2" id="closeCreateModal" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary px-3 py-2" id="saveCreateModal">
                        Save
                    </button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="updateModal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Document Update</h5>
                    <button type="button" class="close" data-dismiss="modal">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-danger error-message" role="alert" style="display: none;">
                        EMPTY
                    </div>

                    <form class="forms-sample" id="updateForm">
                        <div class="form-group">
                            <label for="titleInput">Title *</label>
                            <input type="text" class="form-control" id="titleInput" placeholder="Title">
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger px-3 py-2" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary px-3 py-2" id="saveUpdateModal">
                        Save
                    </button>
                </div>
            </div>
        </div>
    </div>

    {% include 'scripts.html' %}
    <script>
        var currentPage = 1;
        var sort = 'asc';

        /*
         * Refreshes the data table.
         */
        function refreshTable(page) {
            $('#currentPage').text(page);

            // Sends the request to the API.
            axios.get('/api/v1/documents?page=' + page + '&sort=' + sort).then(function (response) {
                $("#table tbody").find("tr:gt(0)").remove();

                var templateRow = $('#table tbody tr:first');
                var documents = response.data;

                // For each document add a row in the data table.
                for (var i in documents) {
                    var document = documents[i];
                    var currentRow = templateRow.clone();
                    $(currentRow).removeClass('d-none');
                    $(currentRow).attr('data-id', document.id);
                    $(currentRow).find('.document_id').text(document.id);
                    $(currentRow).find('.document_title').text(document.title);
                    $(currentRow).find('.document_file_type').text(document.file_type);
                    $(currentRow).find('.btn-download').attr('href', document.file_location)

                    $('#table tbody').append(currentRow);
                }

                $('#prevPageButton, #nextPageButton').prop('disabled', false);

                if (documents.length < 10) {
                    $('#nextPageButton').prop('disabled', true);
                }
            });
        }

        refreshTable(currentPage);

        $('#sortToggleButton').click(function () {
            // Toggles the sorting type.
            if (sort == 'asc') {
                sort = 'desc';
                $('#sortToggleButton').text("Sort : DESC");
            } else {
                sort = 'asc';
                $('#sortToggleButton').text("Sort : ASC");
            }
            refreshTable();
        });

        $('#nextPageButton').click(function () {
            // Go to the next page.
            currentPage += 1;
            refreshTable(currentPage);
        });

        $('#prevPageButton').click(function () {
            // Go to the previous page.
            currentPage -= 1;
            if (currentPage < 1) {
                currentPage = 1;
            }
            refreshTable(currentPage);
        });

        /*
         * Empty the form.
         *
         * @param {Object} modal The modal.
         */
        function clearForm(modal) {
            modal.find('form').find("input").val("");
            var elements = modal.find('form').find("select");
            $.each(elements, function () {
                $(this).val($(this).find("option:first").val());
            });
        }

        $('#closeCreateModal, #closeUpdateModal').click(function () {
            // Empty the forms.
            clearForm($('#createModal'));
            clearForm($('#updateModal'));
            $('#createModal .error-message').hide();
            $('#updateModal .error-message').hide();
        });

        $('input').change(function () {
            // Hides error messages.
            $('#createModal .error-message').hide();
            $('#updateModal .error-message').hide();
        });
        $('input').keydown(function () {
            // Hides error messages.
            $('#createModal .error-message').hide();
            $('#updateModal .error-message').hide();
        });

        // CREATE

        /*
         * Create a document.
         */
        function createDocument() {
            var config = {
                headers: {
                    "Content-Type": "multipart/form-data"
                },
            };
            var formData = new FormData();
            formData.append("title", $('#createForm #titleInput').val());
            formData.append('file', $('#createForm #fileInput')[0].files[0]);

            // Sends the request to the API.
            axios.post('/api/v1/documents', formData, config).then(function (response) {
                $('#createModal').modal('hide');
                clearForm($('#createModal'));
                refreshTable();
            }).catch(function (error) {
                // Shows an error message.
                $('#createModal .error-message').show();
                $('#createModal .error-message').text(error.response.data.message);
            });
        }

        $('#saveCreateModal').click(function () {
            createDocument();
        });

        // UPDATE

        /*
         * Update a document.
         */
        function updateDocument() {
            var config = {
                headers: {
                    "Content-Type": "application/json"
                },
            };
            var id = parseInt($('#updateForm').attr('data-id'));

            // Sends the request to the API.
            axios.patch('/api/v1/documents/' + id, JSON.stringify({
                title: $('#updateForm #titleInput').val(),
            }), config).then(function (response) {
                $('#updateModal').modal('hide');
                clearForm($('#updateModal'));
                refreshTable();
            }).catch(function (error) {
                // Shows an error message.
                $('#updateModal .error-message').show();
                $('#updateModal .error-message').text(error.response.data.message);
            });
        }

        $(document).on('click', '.table-row .btn-update', function () {
            // Opens the form to update a document.
            var id = parseInt($(this).closest('.table-row').attr('data-id'));

            // Sends the request to the API.
            axios.get('/api/v1/documents/' + id).then(function (response) {
                var document = response.data.document;
                $('#updateForm').attr('data-id', document.id);
                $('#updateForm #titleInput').val(document.title);

                $('#updateModal').modal('show');
            });
        });

        $('#saveUpdateModal').click(function () {
            updateDocument();
        });

        // DELETE

        /*
         * Deletes a document.
         *
         * @param {integer} id The document identifier.
         */
        function deleteDocument(id) {
            var config = {
                headers: {
                    "Content-Type": "application/json"
                },
            };


            // Sends the request to the API.
            axios.delete('/api/v1/documents/' + id).then(function () {
                refreshTable();
            });
        }

        $(document).on('click', '.table-row .btn-delete', function () {
            // Deletes a document.
            var id = parseInt($(this).closest('.table-row').attr('data-id'));

            if (!confirm("Are you sure you want to delete document #" + id + "?")) {
                return;
            }

            deleteDocument(id);
        });

    </script>
</body>

</html>
